From 7fa34e4a478ae4e4eab4031e626040a9db210417 Mon Sep 17 00:00:00 2001
From: "Azamat H. Hackimov" <azamat.hackimov@gmail.com>
Date: Sun, 10 Jul 2022 19:53:06 +0300
Subject: [PATCH 1/3] Use shared json11 library

Added option -DUSE_SHARED_JSON11
---
 CMakeLists.txt             | 7 +++++++
 third_party/CMakeLists.txt | 6 +++++-
 2 files changed, 12 insertions(+), 1 deletion(-)

diff --git a/CMakeLists.txt b/CMakeLists.txt
index f099e1deb..c4f364185 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -41,6 +41,7 @@ option(USE_SHARED_CMARK   "Use your installed copy of cmark" off)
 option(USE_SHARED_CURL    "Use your installed copy of curl" off)
 option(USE_SHARED_GIFLIB  "Use your installed copy of giflib" off)
 option(USE_SHARED_JPEGLIB "Use your installed copy of jpeglib" off)
+option(USE_SHARED_JSON11  "Use your installed copy of json11" off)
 option(USE_SHARED_ZLIB    "Use your installed copy of zlib" off)
 option(USE_SHARED_LIBARCHIVE "Use your installed copy of libarchive" off)
 option(USE_SHARED_LIBPNG  "Use your installed copy of libpng" off)
@@ -299,6 +300,12 @@ else()
 endif()
 include_directories(${JPEG_INCLUDE_DIRS})
 
+if(USE_SHARED_JSON11)
+  find_package(PkgConfig QUIET)
+  pkg_check_modules(JSON11 json11)
+  include_directories(${JSON11_INCLUDE_DIRS})
+endif()
+
 if(USE_SHARED_CMARK)
   find_library(CMARK_LIBRARIES NAMES cmark)
   find_path(CMARK_INCLUDE_DIRS NAMES cmark.h)
diff --git a/third_party/CMakeLists.txt b/third_party/CMakeLists.txt
index bdd52435c..88eea9b5e 100644
--- a/third_party/CMakeLists.txt
+++ b/third_party/CMakeLists.txt
@@ -123,7 +123,11 @@ if(NOT USE_SHARED_CMARK)
 endif()
 
 # JSON
-add_subdirectory(json11)
+if(NOT USE_SHARED_JSON11)
+  add_library(json11 STATIC json11/json11.cpp)
+  target_include_directories(json11 PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/json11)
+  #target_compile_options(json11 PRIVATE -fPIC -fno-rtti -fno-exceptions -Wall)
+endif()
 
 # libarchive
 if(NOT USE_SHARED_LIBARCHIVE)
-- 
2.41.0

